/*
 * ActionTraits.hpp
 *
 *  Created on: Sep 26, 2011
 *      Author: heber
 */

#ifndef ACTIONTRAITS_HPP_
#define ACTIONTRAITS_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Actions/ActionTrait.hpp"

namespace MoleCuilder {

/* Templated class for ActionTrait to specialize.
 * I.e. every action specializes its own ActionTraits and inherits the
 * ActionTrait class as interface , e.g. Action called SuperAction:

 * ActionTraits<SuperAction> : public ActionTrait
 *
 * within the constructor of said ActionTraits<SuperAction> the specific
 * information for this derived Action class is then given.
 */
template <class T>
class ActionTraits : public ActionTrait {
public:
  ActionTraits();
  virtual ~ActionTraits();
};

}

#endif /* ACTIONTRAITS_HPP_ */

