/*
 * AtomsCalculation.hpp
 *
 *  Created on: Feb 19, 2010
 *      Author: crueger
 */

#ifndef ATOMSCALCULATION_HPP_
#define ATOMSCALCULATION_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "Actions/Calculation.hpp"

class Dialog;

namespace MoleCuilder {

template<typename T>
class AtomsCalculation : public Calculation<std::vector<T> >
{
public:
  AtomsCalculation(boost::function<T(atom*)> op,const ActionTrait &_trait,AtomDescriptor descr);
  virtual ~AtomsCalculation();

protected:
  virtual std::vector<T>* doCalc();
  virtual Dialog *fillDialog(Dialog *dialog);

private:
  AtomDescriptor descr;
  boost::function<T(atom*)> op;
};

}

#endif /* ATOMSCALCULATION_HPP_ */
