/*
 * ErrorAction.hpp
 *
 *  Created on: Jan 5, 2010
 *      Author: crueger
 */

#ifndef ERRORACTION_HPP_
#define ERRORACTION_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <string>
#include "Actions/Action.hpp"

namespace MoleCuilder {

class ErrorAction : public Action
{
public:
  ErrorAction(const ActionTrait &_trait,const char * _errorMsg,bool _doRegister=true);
  virtual ~ErrorAction();

  virtual bool canUndo();
  virtual bool shouldUndo();

private:
  virtual Dialog * createDialog();
  virtual void getParametersfromValueStorage();
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  std::string errorMsg;
};

}

#endif /* ERRORACTION_HPP_ */
